#include <malloc.h>
#include <string.h>
#include <math.h>


#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include "php.h"
#ifdef _WIN32
#include "ext/standard/info.h"
#endif

#include "wputils.h"


/**
 * List of WordPress tables
 *
 * @since {@internal Version Unknown}}
 * @access private
 * @var array
 */
char* tables[] = {	"users", "usermeta", "posts", "categories", "post2cat", "comments", "links", "link2cat", "options",
					"postmeta", "terms", "term_taxonomy", "term_relationships", "commentmeta" };

/**
 * List of deprecated WordPress tables
 *
 * @since 2.9.0
 * @access private
 * @var array
 */
char* tables[] = {"categories", "post2cat", "link2cat"};



#ifdef _WIN32
inline void EnsureUTF8(char *pStr, int len)
{
	wchar_t *UTF8Str = (wchar_t*)malloc(len * sizeof(wchar_t));

	MultiByteToWideChar( CP_ACP, 0, pStr, -1, UTF8Str, len);
	WideCharToMultiByte(CP_UTF8, 0, UTF8Str, -1, pStr, len, NULL, NULL);
	
	free(UTF8Str);
}
#else
inline void EnsureUTF8(char *pStr, int len){}
#endif

static function_entry wputils_functions[] = {
    PHP_FE(wputils_version, NULL)
    PHP_FE(wputils_day, NULL)
    PHP_FE(wputils_month, NULL)
    {NULL, NULL, NULL}
};


zend_module_entry wputils_module_entry = {
#if ZEND_MODULE_API_NO >= 20010901
    STANDARD_MODULE_HEADER,
#endif
    PHP_WPUTILS_WORLD_EXTNAME,
    wputils_functions,
    NULL,
    NULL,
    NULL,
    NULL,
	PHP_MINFO(wputils),	//    NULL,
#if ZEND_MODULE_API_NO >= 20010901
    PHP_WPUTILS_WORLD_VERSION,
#endif
    STANDARD_MODULE_PROPERTIES
};


#ifdef COMPILE_DL_WPUTILS
ZEND_GET_MODULE(wputils)
#endif

PHP_MINFO_FUNCTION(wputils)
{
	php_info_print_table_start();
	php_info_print_table_row(2, "wputils",           "Greek Utilities");
	php_info_print_table_row(2, "wputils_day()",     "Greek Day names");
	php_info_print_table_end();
}

PHP_FUNCTION(wputils_version)
{
    RETURN_STRING(PHP_WPUTILS_WORLD_VERSION, 1);
}

PHP_FUNCTION(wputils_day)
{
	long dayNumber = 0;

	if ((zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "l", &dayNumber) == FAILURE) ||
	    (dayNumber < 0) ||
	    (dayNumber > 6))
	{
		RETURN_STRING("  ", 1);
    }

	RETURN_STRING(dayNames[CHANGEBASE(dayNumber,0,0)], 1);
}
